Practica14/Proyecto4/Proyecto4/urls.py
from django.contrib import admin
from django.urls import path,include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('',include('apps.Modelo.urls'),),
    path('gatos/',include('apps.Gatos.urls'),),

]

Practica14/Proyecto4/apps/Gatos/urls.py
from django.contrib import admin
from django.urls import path
from apps.Gatos.views import Lista,Detalles,Crear,Actualizar,Eliminar
from apps.Gatos.views import gLista,gDetalles,gCrear,gEliminar,gActualizar

app_name='Gatos'
urlpatterns = [
    path('glista/', gLista.as_view(), name="gLista"),
    path('gdetalles/<int:pk>', gDetalles.as_view(), name="gDetalles"),
    path('gcrear/', gCrear.as_view(), name="gCrear"),
    path('geliminar/<int:pk>', gEliminar.as_view(), name="gEliminar"),
    path('gactualizar/<int:pk>', gActualizar.as_view(), name="gActualizar"),

    path('lista/',Lista,name='Lista'),
    path('detalles/<int:id>',Detalles,name='Detalles'),
    path('crear/',Crear,name='Crear'),
    path('actualizar/<int:id>',Actualizar,name='Actualizar'),
    path('eliminar/<int:id>',Eliminar,name='Eliminar'),
]

Practica14/Proyecto4/apps/Modelo/urls.py
from django.contrib import admin
from django.urls import path
from apps.Modelo.views import Template1,Template2,Template3,Template4,Template5,Template6,Template7,Template8,Template9,Template10,Index
from apps.Modelo.views import ListaAPIView,CrearAPIView,UserAPIView,UserAPICreate

app_name='Modelo'
urlpatterns = [
    path('',Index,name='Index'),
    path('UserAPICreate/',UserAPICreate.as_view(),name="UserAPICreate"),
    path('UserAPIView/',UserAPIView.as_view(),name="UserAPIView"),
    path('ListaAPIView/',ListaAPIView.as_view(),name="ListaAPIView"),
    path('CrearAPIView/',CrearAPIView.as_view(),name="CrearAPIView"),
    path('template1/',Template1,name='template1'),
    path('template2/',Template2,name='template2'),
    path('template3/',Template3,name='template3'),
    path('template4/',Template4,name='template4'),
    path('template5/',Template5,name='template5'),
    path('template6/',Template6,name='template6'),
    path('template7/',Template7,name='template7'),
    path('template8/',Template8,name='template8'),
    path('template9/',Template9,name='template9'),
    path('template10/',Template10,name='template10'),
]

Practica14/Proyecto4/apps/Gatos/models.py
from django.db import models

# Create your models here.
class Gato(models.Model):
	nombre = models.CharField(max_length=30)
	raza = models.CharField(max_length=30)
	hogar = models.CharField(max_length=30)	
	color = models.CharField(max_length=30)
	edad = models.IntegerField()
	size = models.FloatField()
	peso = models.FloatField()
	date = models.DateField()

	def __str__(self):
		return self.nombre

Practica14/Proyecto4/apps/Modelo/models.py
from django.db import models

# Create your models here.

Practica14/Proyecto4/apps/Gatos/forms.py
from django import forms

from apps.Gatos.models import Gato

class GatoForm(forms.ModelForm):
	nombre = forms.CharField(widget=forms.TextInput(attrs={"placeholder":"Nombre","class":"form-control"}))
	raza = forms.CharField(widget=forms.TextInput(attrs={"placeholder":"Raza","class":"form-control"}))
	hogar = forms.CharField(widget=forms.TextInput(attrs={"placeholder":"hogar","class":"form-control"}))
	color = forms.CharField(widget=forms.TextInput(attrs={"placeholder":"color","class":"form-control"}))
	edad = forms.IntegerField(widget=forms.NumberInput(attrs={"placeholder":"edad","class":"form-control"}))
	size = forms.FloatField(widget=forms.TextInput(attrs={"placeholder":"Size","class":"form-control"}))
	peso = forms.FloatField(widget=forms.TextInput(attrs={"placeholder":"peso","class":"form-control"}))
	date = forms.DateField(widget=forms.DateInput(attrs={"placeholder":"Registro","class":"form-control"}))
	class Meta:
		model = Gato
		fields = [
			"nombre",
			"raza",
			"hogar",
			"color",
			"edad",
			"size",
			"peso",
			"date",

		]
			

Practica14/Proyecto4/apps/Gatos/views.py
from django.shortcuts import render,redirect
from apps.Gatos.models import Gato
from apps.Gatos.forms import GatoForm
from django.views.generic import ListView,CreateView,DetailView,UpdateView,DeleteView
from django.urls import reverse_lazy
# Create your views here.

#Generics Views
class gLista(ListView):
	model = Gato
	template_name ='Gatos/glista.html'

class gDetalles(DetailView):
	model  = Gato
	template_name = 'Gatos/detalles.html'

class gCrear(CreateView):
	model = Gato
	form_class = GatoForm
	template_name = 'Gatos/crear.html'
	success_url = reverse_lazy('Gatos:gLista')

class gActualizar(UpdateView):
	model = Gato
	form_class = GatoForm
	template_name = 'Gatos/crear.html'
	success_url = reverse_lazy('Gatos:gLista')

class gEliminar(DeleteView):
	model  = Gato
	template_name = 'Gatos/geliminar.html'
	success_url = reverse_lazy('Gatos:gLista')
	
#Funciones 
def Lista(request):
	qs = Gato.objects.all()
	context ={
		'gatos':qs
	}
	return render(request,'Gatos/lista.html',context)

def Detalles(request,id):
	qs = Gato.objects.get(id=id)
	context ={
		'gato':qs
	}
	return render(request,'Gatos/detalles.html',context)


def Crear(request):
	if request.method == 'POST':
		form = GatoForm(request.POST)
		if form.is_valid():
			form.save()
			return redirect('Gatos:Lista')
	else:
		form = GatoForm()

	return render(request,'Gatos/crear.html',{'form':form})

def Actualizar(request,id):
	qs = Gato.objects.get(id=id)
	if request.method == 'GET':
		form = GatoForm(instance = qs)
	else:
		form = GatoForm(request.POST, instance = qs)
		if form.is_valid():
			form.save()
		return redirect('Gatos:Lista')
	return render(request,'Gatos/crear.html',{'form':form})

def Eliminar(reques,id):
	qs = Gato.objects.get(id=id)
	qs.delete()
	return redirect('Gatos:Lista')

Practica14/Proyecto4/apps/Modelo/views.py
from django.shortcuts import render
from apps.Modelo.serializer import ApiReadOnly,ApiUser
from rest_framework.generics import ListAPIView,CreateAPIView
from apps.Gatos.models import Gato 
from django.contrib.auth.models import User

# Create your views here.

class UserAPICreate(CreateAPIView):
    serializer_class = ApiUser

    def perform_create(self,serializer):
        serializer.save()

class UserAPIView(ListAPIView):
    serializer_class = ApiUser

    def get_queryset(self,*args,**kwargs):
        return User.objects.all()

class CrearAPIView(CreateAPIView):
    serializer_class = ApiReadOnly

    def perform_create(self,serializer):
        serializer.save()

class ListaAPIView(ListAPIView):
    serializer_class = ApiReadOnly

    def get_queryset(self,*args,**kwargs):
        return Gato.objects.all()

def Index(request):
    return render(request,'index.html')
    
def Template1(request):
    context = {
        'message': "Soy el Template 1 - Proyecto 4",
    }
    return render(request, 'Modelo/template1.html', context)

def Template2(request):
    context = {
        'message': "Soy el Template 2 - Proyecto 4",
    }
    return render(request, 'Modelo/template2.html', context)

def Template3(request):
    context = {
        'message': "Soy el Template 3 - Proyecto 4",
    }
    return render(request, 'Modelo/template3.html', context)

def Template4(request):
    context = {
        'message': "Soy el Template 4 - Proyecto 4",
    }
    return render(request, 'Modelo/template4.html', context)

def Template5(request):
    context = {
        'message': "Soy el Template 5 - Proyecto 4",
    }
    return render(request, 'Modelo/template5.html', context)

def Template6(request):
    context = {
        'message': "Soy el Template 6 - Proyecto 4",
    }
    return render(request, 'Modelo/template6.html', context)

def Template7(request):
    context = {
        'message': "Soy el Template 7 - Proyecto 4",
    }
    return render(request, 'Modelo/template7.html', context)

def Template8(request):
    context = {
        'message': "Soy el Template 8 - Proyecto 4",
    }
    return render(request, 'Modelo/template8.html', context)

def Template9(request):
    context = {
        'message': "Soy el Template 9 - Proyecto 4",
    }
    return render(request, 'Modelo/template9.html', context)

def Template10(request):
    context = {
        'message': "Soy el Template 10 - Proyecto 4",
    }
    return render(request, 'Modelo/template10.html', context)

Practica14/Proyecto4/templates/Gatos/crear.html
{% extends 'index.html' %}

{% block container %}
<form method="POST">
	{% csrf_token%}	
	{{form.as_p}}
	<button class="btn btn-outline-dark" type="submit">Guardar</button>
</form>
{% endblock %}

Practica14/Proyecto4/templates/Gatos/detalles.html
{% extends 'index.html' %}

{% block container %}
<div class="row">
	<div class="col-md-3"></div>
<div class="col-md-3 mt-3">
	<table class="table">
		<tr>
			<td><b>Nombre</b></td>
			<td>{{gato.nombre}}</td>
		</tr>
		<tr>
			<td><b>Raza</b></td>
			<td>{{gato.raza}}</td>
		</tr>
		<tr>
			<td><b>Hogar</b></td>
			<td>{{gato.hogar}}</td>
		</tr>
		<tr>
			<td><b>Color</b></td>
			<td>{{gato.color}}</td>
		</tr>
		<tr>
			<td><b>Edad</b></td>
			<td>{{gato.edad}} años</td>
		</tr>
		<tr>
			<td><b>size</b></td>
			<td>{{gato.size}} cm</td>
		</tr>
		<tr>
			<td><b>Peso</b></td>
			<td>{{gato.peso}} kg</td>
		</tr>
		<tr>
			<td><b>Registro</b></td>
			<td>{{gato.date}}</td>
		</tr>		
		<tr>
			<td><b></b></td>
			<td><a href="{% url 'Gatos:Lista'%}">Regresar</a></td>
		</tr>	
</table>
</div>	
</div>


{% endblock %}

Practica14/Proyecto4/templates/Gatos/geliminar.html
{% extends 'index.html' %}

{% block container %}
<div class="row">
	<div class="col-md">
		<h3>Esta eliminando {{ object }}</h3>
		<form method="POST">
			{% csrf_token %}
			<button type="submit" class="btn btn-outline-danger">Eliminar</button>
			<a href="{% url 'Gatos:gLista' %}" class="btn btn-outline-dark">Regresar</a>
		</form>
	</div>
</div>


{% endblock %}

Practica14/Proyecto4/templates/Gatos/glista.html
{% extends 'index.html' %}

{% block container %}
<table class="table">
	<th>Nombre</th>
	<th>Raza</th>
	<th>Registro</th>
	<th></th>
	<th></th>
	{% for gato in object_list %}
		<tr>
			<td>{{gato.nombre}}</td>
			<td>{{gato.raza}}</td>
			<td>{{gato.date}}</td>
			<td><a href="{% url 'Gatos:gDetalles' gato.id %}">Detalles</a></td>
			<td><a href="{% url 'Gatos:gActualizar' gato.id %}">Actualizar</a></td>
			<td><a href="{% url 'Gatos:gEliminar' gato.id %}">Eliminar</a></td>
		</tr>
	{% endfor %}
</table>
			<a class="btn btn-outline-dark" href="{% url 'Gatos:gCrear'%}">Nuevo</a>

{% endblock %}

Practica14/Proyecto4/templates/Gatos/lista.html
{% extends 'index.html' %}

{% block container %}
<table class="table">
	<th>Nombre</th>
	<th>Raza</th>
	<th>Registro</th>
	<th></th>
	<th></th>
	{% for gato in gatos %}
		<tr>
			<td>{{gato.nombre}}</td>
			<td>{{gato.raza}}</td>
			<td>{{gato.date}}</td>
			<td><a href="{% url 'Gatos:Detalles' gato.id %}">Detalles</a></td>
			<td><a href="{% url 'Gatos:Actualizar' gato.id %}">Actualizar</a></td>
			<td><a href="{% url 'Gatos:Eliminar' gato.id %}">Eliminar</a></td>
		</tr>
	{% endfor %}
</table>
			<a class="btn btn-outline-dark" href="{% url 'Gatos:Crear'%}">Nuevo</a>
{% endblock %}